#include <stdio.h>
#include <stdlib.h>


struct rect 
{
    double x1;
    double y1;
    double x2;
    double y2;
    int no;
};

struct ival 
{
    double y_s;
    double y_e;
    int used[100];
};


struct rect map[1000];
int no_m;

struct rect y_s[1000];
struct rect y_e[1000];
struct rect x_s[1000];
struct rect x_e[1000];

struct ival ivals[1000];/*201];*/
int no_ivals;

int y_s_cmp(const void *a, const void *b) {
    double f = ((struct rect *)a)->y1 - ((struct rect *)b)->y1;
    if (f>0) return 1;
    if (f<0) return -1;
    return 0;
}
int y_e_cmp(const void *a, const void *b) {
    double f =  ((struct rect *)a)->y2 - ((struct rect *)b)->y2;
    if (f>0) return 1;
    if (f<0) return -1;
    return 0;
}
int x_s_cmp(const void *a, const void *b) {
    double f =  ((struct rect *)a)->x1 - ((struct rect *)b)->x1;
    if (f>0) return 1;
    if (f<0) return -1;
    return 0;
}
int x_e_cmp(const void *a, const void *b) {
    double f =  ((struct rect *)a)->x2 - ((struct rect *)b)->x2;
    if (f>0) return 1;
    if (f<0) return -1;
    return 0;
}





int main() 
{
    FILE *in;
    int CASE = 1;
    in = fopen("atlantis.in", "r");

    while (1) {
        int i,j;

        double result = 0.0;

        fscanf(in, " %d ", &no_m);

        if (no_m==0) break;

        printf("Test case #%d\n", CASE++);

        for (i=0; i<no_m; i++) {
            fscanf(in, " %lf %lf %lf %lf ",
                   &(map[i].x1),
                   &(map[i].y1),
                   &(map[i].x2),
                   &(map[i].y2));
            map[i].no = i;
            if ((map[i].x1==map[i].x2) ||
                (map[i].y1==map[i].y2))
            {
                no_m--;
                i--;
            }
            
        }
        
        memcpy(y_s, map, no_m*sizeof(struct rect));
        qsort(y_s, no_m, sizeof(struct rect), y_s_cmp);
        memcpy(y_e, map, no_m*sizeof(struct rect));
        qsort(y_e, no_m, sizeof(struct rect), y_e_cmp);

        {
            int y__s = 0;
            int y__e = 0;
            double y = y_s[y__s++].y1;

            no_ivals = 0;

            memset(ivals[no_ivals].used, 0,
                   sizeof(ivals[no_ivals].used));
            ivals[no_ivals].used[y_s[0].no] = 1;
            ivals[no_ivals++].y_s = y;

/*             while (y!=y_e[no_m-1].y2) { */
            while (y__e!=no_m) {
                double diff;

                memcpy(ivals[no_ivals].used, 
                       ivals[no_ivals-1].used,
                       sizeof(ivals[no_ivals].used));

                diff =
                    ((y__s==no_m)?100001:y_s[y__s].y1) -
                    ((y__e==no_m)?100001:y_e[y__e].y2);
                if (diff>0.0) {
                    ivals[no_ivals].used[y_e[y__e].no] = 0;
                    y = y_e[y__e++].y2;
                }
                else {
                    /* diff<0.0 */
                    ivals[no_ivals].used[y_e[y__s].no] = 1;
                    y = y_s[y__s++].y1;
                }
                
                ivals[no_ivals].y_s = y;
                ivals[no_ivals-1].y_e = y;

                no_ivals++;
            }
            no_ivals--;
        }

/*        for (i=0; i<no_ivals; i++) {
            printf("Interval %d\n", i);
            printf("\ty_s=%f\n", ivals[i].y_s);
            printf("\ty_e=%f\n", ivals[i].y_e);
            printf("\tused = ");
            for (j=0; j<no_m; j++) {
                printf("%d ", ivals[i].used[j]);
            }
            printf("\n");
            }*/
        
    
        for (i=0; i<no_ivals; i++) {
            int no_maps = 0;
            double x_tot = 0.0;

            for (j=0; j<no_m; j++) {
                if (ivals[i].used[j]) {
                    x_s[no_maps] = map[j];
                    x_e[no_maps] = map[j];
                    no_maps++;
                }
            }
        
            qsort(x_s, no_maps, sizeof(struct rect), x_s_cmp);
            qsort(x_e, no_maps, sizeof(struct rect), x_e_cmp);

            if (no_maps>0) 
            {
                int x__s = 0;
                int x__e = 0;
                double last_x;
                double x = x_s[x__s++].x1;
                int counter = 1;
                
/*                 while (x!=x_e[no_maps-1].x2) { */
                while (x__e!=no_maps) {
                    double diff;
                    last_x = x;

/*                     printf("x__s = %d, x__e = %d\n", x__s, x__e); */

                    diff =
                        ((x__s==no_maps)?100001:x_s[x__s].x1) -
                        ((x__e==no_maps)?100001:x_e[x__e].x2);
                    if (diff>0.0) {
                        x = x_e[x__e++].x2;
                    }
                    else {
                        /* diff<0.0 */
                        x = x_s[x__s++].x1;
                    }
                    
/*                     printf("counter = %d\n", counter); */
                    if (counter>0) {
                        x_tot += x-last_x;
/*                         printf("x=%f, last_x=%f\n", x, last_x); */
                    }

                    if (diff>=0.0) {
                        counter--;
                    }
                    else {
                        /* diff<0.0 */
                        counter++;
                    }
                }
/*                  printf("x_tot = %f\n", x_tot);*/

            }
/*              printf("no_ivals=%d, i=%d\n", no_ivals, i);*/
            result += x_tot*(ivals[i].y_e - ivals[i].y_s);
        }
        printf("Total explored area: %.2f\n", result);
    }
    return 0;
}

