#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

struct _x
{
  char fname[41];
  char lname[41];
} *names;
int nameNo;

int **rel;
int *depths;

void rebuildRel()
{
  int i;
  rel=realloc(rel,sizeof(int*)*(nameNo+1));
  rel[nameNo]=(int*)malloc(sizeof(int)*(nameNo+1));
  for (i=0;i<nameNo;i++){
    rel[i]=realloc(rel[i],sizeof(int)*(nameNo+1));
    rel[i][nameNo]=0;
    rel[nameNo][i]=0;
  }
  rel[nameNo][nameNo]=0;
  
}

int getInd(char *fname, char *lname)
{
  int i=0;
  for (i=0;i<nameNo;i++){
    if ((!strcmp(names[i].fname,fname))&&(!strcmp(names[i].lname,lname))){
      return i;
    }
  }
  return -1;
}

void doDepth()
{
  int depth=0,nextparent,parent,i;
  parent=getInd("P.","Erdos");
  depths=malloc(nameNo*sizeof(int));
  
  for (i=0;i<nameNo;i++){
    depths[i]=-1;
  }
  depths[parent]=0;
  while (parent!=-1){
    
    nextparent=-1;
    for (i=0;i<nameNo;i++){
      if (rel[parent][i] && (depths[i]==-1)){
	depths[i]=depth+1;
      }
    }
    for (i=parent+1;i<nameNo;i++){
      if (depths[i]==depth) {
	nextparent=i;
	
	break;
      }
      
    }
    if (nextparent==-1){
      depth++;
      for (i=0;i<nameNo;i++){
	if (depths[i]==depth){
	  nextparent=i;
	  break;
	}
	
      }
    }
    
    parent=nextparent

;
  }
  
}


int main()
{
  int p,n,db=1,i,j,q;
  char fname[41];
  char lname[41];
  char c;
  
  int indNo;
  int nameInd[250];
  
  FILE *in;
  in=fopen("erdos.in","r");
  
  while(1){
    fscanf(in," %d %d ",&p,&n);
    if ((p==0)&&(n==0)) break;
    nameNo=0;
    
    names=NULL;
    for (q=0;q<p;q++){
    indNo=0;
      
    while(1){
      lname[0]=0;
      while ((c=fgetc(in))!=','){
	int k;
	k=strlen(lname);
	lname[k]=c;
	lname[k+1]=0;
      }
      fgetc(in);

      fname[0]=0;
      while (((c=fgetc(in))!=',') && (c!=':')){
	int k;
	k=strlen(fname);
	fname[k]=c;
	fname[k+1]=0;
      }


      nameInd[indNo]=getInd(fname,lname);
      if (nameInd[indNo]==-1){
	rebuildRel();
	nameInd[indNo++]=nameNo;
	names=realloc(names,sizeof(struct _x)*(++nameNo));
	
	strcpy(names[nameNo-1].fname,fname);
	strcpy(names[nameNo-1].lname,lname);
      }
      else indNo++;
      
      
      fgetc(in);
      
      if (c==':') break;
    }
    while (fgetc(in)!='\n') ;

    
    
    for (i=0;i<indNo;i++){
      for (j=0;j<indNo;j++){
	if (i!=j) {
	  rel[nameInd[i]][nameInd[j]]=1;
	}
      }
    }
    
    }
    
    doDepth();
    printf("Database #%d\n",db++);
    for (i=0;i<n;i++){
      
      lname[0]=0;
      while ((c=fgetc(in))!=','){
	int k;
	k=strlen(lname);
	lname[k]=c;
	lname[k+1]=0;
      }
      fgetc(in);
      fname[0]=0;
      while ((c=fgetc(in))!='\n'){
	int k;
	k=strlen(fname);
	fname[k]=c;
	fname[k+1]=0;
      }
      
      j=getInd(fname,lname);
      printf("%s, %s %d: ",lname,fname,j);
      if (depths[j]==-1) printf("infinity\n");
      else printf("%d\n",depths[j]);
    }
    
  }
  

  return 0;
}
